package com.realnet.basicp1.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basicp1.Entity.Template;
import com.realnet.basicp1.Services.TemplateService ;




@RequestMapping(value = "/Template")
 @CrossOrigin("*") 
@RestController
public class TemplateController {
	@Autowired
	private TemplateService Service;

@Value("${projectPath}")
	private String projectPath;
 




	@PostMapping("/Template")
		  public Template Savedata(@RequestBody Template data) {
		Template save = Service.Savedata(data)	;



		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Template/{id}")
	public  Template update(@RequestBody Template data,@PathVariable Integer id ) {
		Template update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Template/getall/page")
	public Page<Template> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Template> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Template")
	public List<Template> getdetails() {
		 List<Template> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Template")
	public List<Template> getallwioutsec() {
		 List<Template> get = Service.getdetails();		
		return get;
}
@GetMapping("/Template/{id}")
	public  Template  getdetailsbyId(@PathVariable Integer id ) {
		Template  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Template/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}





}